#!/usr/bin/python2.7

import unittest
from mocker import Mocker
import os

from setup import *
from sandglass import distinfo
import sandglass

class UtilsTest(TestCaseTempDir):
	"""
	Module sandglass.distinfo Unit Test.
	"""

	def test_distinfo_get_instance_delegation(self):
		"""Method 'distinfo.get_instance' should be delegated to classmethod 'distinfo.DistInfo.get_instance'."""

		mocker = Mocker()
		DistInfo = mocker.replace("sandglass.distinfo.DistInfo")
		DistInfo.get_instance()
		with mocker:
			distinfo.get_instance()

	def test_distinfo_detects_fedora(self):
		"""Classmethod DistInfo.get_instance() should detect Fedora distribution."""

		if not os.path.exists("/etc/redhat-release"):
			self.skipTest("You are not running on RHEL or Fedora.")

		self.assertIsInstance(distinfo.get_instance(), sandglass.distinfo.fedora.DistInfo)

	# TODO: test interaction with RPM database

if __name__ == "__main__":
	unittest.main()
